/*_############################################################################
  _## 
  _##  SNMP4J-AgentJMX - JMXRowSupport.java  
  _## 
  _##  Copyright (C) 2006-2009  Frank Fock (SNMP4J.org)
  _##  
  _##  This program is free software; you can redistribute it and/or modify
  _##  it under the terms of the GNU General Public License version 2 as 
  _##  published by the Free Software Foundation.
  _##
  _##  This program is distributed in the hope that it will be useful,
  _##  but WITHOUT ANY WARRANTY; without even the implied warranty of
  _##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  _##  GNU General Public License for more details.
  _##
  _##  You should have received a copy of the GNU General Public License
  _##  along with this program; if not, write to the Free Software
  _##  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
  _##  MA  02110-1301  USA
  _##  
  _##########################################################################*/

package org.snmp4j.agent.mo.jmx;

import org.snmp4j.smi.OID;
import javax.management.ObjectName;

/**
 * The <code>JMXRowSupport</code> maps an internal row identifier of a table
 * to a MBean <code>ObjectName</code>.
 *
 * @author Frank Fock
 * @version 1.0
 */
public interface JMXRowSupport {

  /**
   * Maps the supplied internal row key to a MBean <code>ObjectName</code>
   * @param tableOID
   *    a table entry OID (e.g., ifEntry).
   * @param rowKey
   *    an Object that identifies a MBean representing the corresponding row
   *    of the through <code>tableOID</code> identified table.
   * @return
   *    the <code>ObjectName</code> of the MBean associated with the specified
   *    row.
   */
  ObjectName getRowMBean(OID tableOID, Object rowKey);
}
